import { world } from "@minecraft/server";

function getRanks(player) {
    let rankPrefix = "rank:";
    let defaultRank = "§7Player";

    const ranks = player.getTags().map((tags) => {
        if (!tags.startsWith(rankPrefix)) return null;
        return tags.substring(rankPrefix.length);
    }).filter((tag) => tag);
    return ranks.length == 0 ? [defaultRank] : ranks;
}

world.beforeEvents.chatSend.subscribe((data) => {
    data.cancel = true;

    let player = data.sender;
    let content = data.message;

    world.sendMessage(`§8[§f${getRanks(player)}§8] §f${player.name}: §7${content}`);
});